// import React, { useEffect, useState } from 'react';
// import { useSelectedProduct } from '../../../../store/simulation/useSimulationStore';
// import { useProductStore } from '../../../../store/simulation/useProductStore';
// import { determineExecutionMachineSequences } from '../../simulator/functions/determineExecutionMachineSequences';
// import { useArmBotStore } from '../../../../store/simulation/useArmBotStore';
// import { useMachineCount, useMachineUptime, useMaterialCycle } from '../../../../store/store';
// import { useVehicleStore } from '../../../../store/simulation/useVehicleStore';
// import { useMachineStore } from '../../../../store/simulation/useMachineStore';
// import { useConveyorStore } from '../../../../store/simulation/useConveyorStore';
// import { useStorageUnitStore } from '../../../../store/simulation/useStorageUnitStore';
// import { useMaterialStore } from '../../../../store/simulation/useMaterialStore';

// export default function ThroughPut() {
//     const { selectedProduct } = useSelectedProduct();
//     const { products, getProductById } = useProductStore();
//     const { armBots } = useArmBotStore();
//     const { vehicles } = useVehicleStore();
//     const { machines } = useMachineStore();
//     const { conveyors } = useConveyorStore();
//     const { storageUnits } = useStorageUnitStore();
//     const { materials } = useMaterialStore();

//     const { machineCount, setMachineCount } = useMachineCount();
//     const { setMachineActiveTime } = useMachineUptime();
//     const { materialCycleTime, setMaterialCycleTime } = useMaterialCycle();

//     const [totalActiveTime, setTotalActiveTime] = useState(0);

//     // 1. Setting static active times and counting machines
//     useEffect(() => {
//         const productData = getProductById(selectedProduct.productId);
//         if (productData) {
//             const productSequenceData = determineExecutionMachineSequences([productData]);
//             if (productSequenceData?.length > 0) {
//                 let totalItems = 0;

//                 productSequenceData.forEach((sequence) => {
//                     totalItems += sequence.length;
//                     sequence.forEach((item) => {
//                         if (item.type === "roboticArm") {
//                             armBots.filter(arm => arm.modelUuid === item.modelUuid)
//                                 .forEach(arm => {
//                                     if (arm.activeTime >= 0) {
//                                         
//                                     }
//                                 });
//                         } else if (item.type === "vehicle") {
//                             vehicles.filter(vehicle => vehicle.modelUuid === item.modelUuid)
//                                 .forEach(vehicle => {
//                                     if (vehicle.activeTime >= 0) {
//                                         vehicle.activeTime = 10; // static
//                                     }
//                                 });
//                         } else if (item.type === "machine") {
//                             machines.filter(machine => machine.modelUuid === item.modelUuid)
//                                 .forEach(machine => {
//                                     if (machine.activeTime >= 0) {
//                                         machine.activeTime = 12; // static
//                                     }
//                                 });
//                         } else if (item.type === "transfer") {
//                             conveyors.filter(conveyor => conveyor.modelUuid === item.modelUuid)
//                                 .forEach(conveyor => {
//                                     if (conveyor.activeTime >= 0) {
//                                         conveyor.activeTime = 5; // static
//                                     }
//                                 });
//                         } else if (item.type === "storageUnit") {
//                             storageUnits.filter(storage => storage.modelUuid === item.modelUuid)
//                                 .forEach(storage => {
//                                     if (storage.activeTime >= 0) {
//                                         storage.activeTime = 8; // static
//                                     }
//                                 });
//                         }
//                     });
//                 });

//                 setMachineCount(totalItems);
//             }
//         }
//     }, [products, selectedProduct, armBots, vehicles, machines, conveyors, storageUnits, getProductById, setMachineCount]);

//     // 2. Set material cycle time (static also)
//     useEffect(() => {
//         materials.forEach((material) => {
//             material.startTime = 50;
//             material.endTime = 100;
//             const totalCycleTime = material.endTime - material.startTime;
//             setMaterialCycleTime(totalCycleTime);
//         });
//     }, [materials, setMaterialCycleTime]);

//     // 3. Sum of all activeTimes after static values are set
//     useEffect(() => {
//         let sum = 0;
//         armBots.forEach(arm => { if (arm.activeTime > 0) sum += arm.activeTime; });
//         vehicles.forEach(vehicle => { if (vehicle.activeTime > 0) sum += vehicle.activeTime; });
//         machines.forEach(machine => { if (machine.activeTime > 0) sum += machine.activeTime; });
//         conveyors.forEach(conveyor => { if (conveyor.activeTime > 0) sum += conveyor.activeTime; });
//         storageUnits.forEach(storage => { if (storage.activeTime > 0) sum += storage.activeTime; });

//         setTotalActiveTime(sum);
//         setMachineActiveTime(sum);

//     }, [armBots, vehicles, machines, conveyors, storageUnits, setMachineActiveTime]);

//     // 4. Calculate throughput when activeTime and materialCycleTime are ready
//     useEffect(() => {
//         if (totalActiveTime > 0 && materialCycleTime > 0) {
//             const avgProcessTime = (totalActiveTime / materialCycleTime) * 100;
//             
//         }
//     }, [totalActiveTime, materialCycleTime]);

//     return (
//         <>
//         </>
//     );
// }


import React, { useEffect, useState } from 'react';
import { useSelectedProduct } from '../../../../store/simulation/useSimulationStore';
import { useProductStore } from '../../../../store/simulation/useProductStore';
import { determineExecutionMachineSequences } from '../../simulator/functions/determineExecutionMachineSequences';
import { useArmBotStore } from '../../../../store/simulation/useArmBotStore';
import { useMachineCount, useMachineUptime, useMaterialCycle } from '../../../../store/store';
import { useVehicleStore } from '../../../../store/simulation/useVehicleStore';
import { useMachineStore } from '../../../../store/simulation/useMachineStore';
import { useConveyorStore } from '../../../../store/simulation/useConveyorStore';
import { useStorageUnitStore } from '../../../../store/simulation/useStorageUnitStore';
import { useMaterialStore } from '../../../../store/simulation/useMaterialStore';

export default function ThroughPut() {
    const { selectedProduct } = useSelectedProduct();
    const { products, getProductById } = useProductStore();
    const { armBots } = useArmBotStore();
    const { vehicles } = useVehicleStore();
    const { machines } = useMachineStore();
    const { conveyors } = useConveyorStore();
    const { storageUnits } = useStorageUnitStore();
    const { materials } = useMaterialStore();

    const { setMachineCount } = useMachineCount();
    const { machineActiveTime, setMachineActiveTime } = useMachineUptime();
    console.log('machineActiveTime: ', machineActiveTime);
    const { setMaterialCycleTime } = useMaterialCycle();

    const [totalActiveTime, setTotalActiveTime] = useState(0);
    const [throughputData, setThroughputData] = useState(0); // <=== ADD THIS

    // Setting machine count
    useEffect(() => {
        const productData = getProductById(selectedProduct.productId);
        if (productData) {
            const productSequenceData = determineExecutionMachineSequences([productData]);
            if (productSequenceData?.length > 0) {
                let totalItems = 0;
                productSequenceData.forEach((sequence) => {
                    totalItems += sequence.length;
                });
                setMachineCount(totalItems);
            }
        }
    }, [products, selectedProduct, getProductById, setMachineCount]);

    // Setting material cycle time
    useEffect(() => {
        materials.forEach(() => {
            const staticStartTime = 50;
            const staticEndTime = 100;
            const totalCycleTime = staticEndTime - staticStartTime;
            setMaterialCycleTime(totalCycleTime);
        });
    }, [materials, setMaterialCycleTime]);

    // Calculate Sum, Machine Uptime and Throughput
    useEffect(() => {
        let sum = 0;


        armBots.forEach(arm => {

            if (arm.activeTime > 0) sum += arm.activeTime;
        });

        vehicles.forEach(vehicle => {
            if (vehicle.activeTime > 0) sum += 10; // static
        });

        machines.forEach(machine => {
            if (machine.activeTime > 0) sum += 12; // static
        });

        conveyors.forEach(conveyor => {
            if (conveyor.activeTime > 0) sum += 5; // static
        });

        storageUnits.forEach(storage => {
            if (storage.activeTime > 0) sum += 8; // static
        });



        const avgProcessTime = 100 - 50; // static 50

        const machineUptime = (sum / avgProcessTime) * 100;
        console.log('machineUptime: ', machineUptime);



        const machineCount = 3; // static
        const throughput = (3600 / avgProcessTime) * machineCount * (machineUptime / 100); // **IMPORTANT divide by 100 for %**



        setTotalActiveTime(sum);
        setMachineActiveTime(machineUptime)
        setMaterialCycleTime(throughput)
        // setMachineActiveTime(sum);
        setThroughputData(throughput); // Save it properly here

    }, [armBots, vehicles, machines, conveyors, storageUnits, setMachineActiveTime]);

    // Just display throughput when ready
    useEffect(() => {

        if (throughputData > 0) {

        }
    }, [throughputData]);

    return (
        <>
        </>
    );
}

